Subject: bug#17978: 24.3; forward-paragraph broken with javadocs

From: Stefan Monnier <[email-masked]>
Date: Wed, 09 Jul 2014 23:06:57 -0400

> C-{ and C-} should cycle between blank lines. But the reason why this
> doesn't happen in java-mode, is because Java redefines the definition of a
> paragraph. It sets the paragraph-start variable (among other variables) so
> that when I M-q to fill-paragraph, it'll work correctly *within* the
> Javadoc, rather than reflowing my code into a jumbled mess.

Ah, I see, yes, that makes sense.  The fix is to not change
paragraph-start (and friends) in the major-mode hook but instead to
define override the fill-forward-paragraph-function with a function
which let-binds those vars and then calls forward-paragraph.

See lisp/vc/add-log.el for an example.

        Stefan